package mi.hdm.components;

import javafx.scene.control.Label;
import mi.hdm.helpers.ColorHelper;
import mi.hdm.recipes.Category;

/**
 * Label UI element for categories with the appropriate background color
 */
public class CategoryPreviewLabel extends Label {
    private final Category category;

    public CategoryPreviewLabel(Category category) {
        super(category.getName());
        this.category = category;

        //TODO: border radius on the style?
        this.setStyle(
                "-fx-background-color:" + category.getColourCode() + ";" +
                        "-fx-padding: 4px;" +
                        "-fx-text-fill: " + ColorHelper.getTextColorForBackground(getAssociatedCategory().getColourCode()) + ";"
        );
    }

    public Category getAssociatedCategory() {
        return category;
    }
}
