package mi.hdm.controllers;

import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import mi.hdm.recipes.IngredientManager;
import mi.hdm.recipes.Recipe;
import mi.hdm.recipes.RecipeManager;
import mi.hdm.recipes.RecipeSearch;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.util.Collection;

public class HeaderController extends BaseController {
    private final static Logger log = LogManager.getLogger(HeaderController.class);

    @FXML
    private TextField searchBox;

    private final RecipeManager recipeManager;
    private final IngredientManager ingredientManager;

    private Collection<Recipe> lastSearchResults;

    public HeaderController(RecipeManager recipeManager, IngredientManager ingredientManager) {
        this.recipeManager = recipeManager;
        this.ingredientManager = ingredientManager;
        lastSearchResults = recipeManager.getRecipes();
    }

    @FXML
    public void searchByQuery() {
        String query = searchBox.getText();
        log.debug("User submitted search box");
        RecipeSearch recipeSearch = new RecipeSearch(recipeManager, ingredientManager);
        lastSearchResults = recipeSearch.searchByQuery(recipeManager.getRecipes(), query); //TODO: pass last search results
        System.out.println("Results: ");
        lastSearchResults.forEach(result -> System.out.println("   " + result.getName()));
    }

    @FXML
    public void changeSceneToHome() {
        changeScene(View.MAIN);
    }

    @FXML
    public void changeSceneToShoppingList() {
        changeScene(View.SHOPPINGLIST_VIEW);
    }

    @FXML
    public void changeSceneToMealPlan() {
        changeScene(View.MEALPLAN_VIEW);
    }

    @FXML
    public void changeSceneToIngredientCreator() {
        changeScene(View.INGREDIENT_CREATOR);
    }
}
